/*
 * JS for startScreen generated by Appery.io
 */

Apperyio.getProjectGUID = function() {
    return '6b4d1a8b-bc39-4874-913d-7ce182b991f5';
};

function navigateTo(outcome, useAjax) {
    Apperyio.navigateTo(outcome, useAjax);
}

// Deprecated


function adjustContentHeight() {
    Apperyio.adjustContentHeightWithPadding();
}

function adjustContentHeightWithPadding(_page) {
    Apperyio.adjustContentHeightWithPadding(_page);
}

function setDetailContent(pageUrl) {
    Apperyio.setDetailContent(pageUrl);
}

Apperyio.AppPages = [{
    "name": "Info",
    "location": "Info.html"
}, {
    "name": "startScreen",
    "location": "startScreen.html"
}, {
    "name": "startScreen_clone_2",
    "location": "startScreen_clone_2.html"
}];

startScreen_js = function(runBeforeShow) {

    /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'mobilegrid_19': 'startScreen_mobilegrid_19',
        'mobilegridcell_20': 'startScreen_mobilegridcell_20',
        'mobilegridcell_21': 'startScreen_mobilegridcell_21',
        'veganlist_icon': 'startScreen_veganlist_icon',
        'mobilegridcell_24': 'startScreen_mobilegridcell_24',
        'mobilegrid_13': 'startScreen_mobilegrid_13',
        'cell1': 'startScreen_cell1',
        'search_bar': 'startScreen_search_bar',
        'mobilegridcell_15': 'startScreen_mobilegridcell_15',
        'mobileimage_57': 'startScreen_mobileimage_57',
        'spacer_35': 'startScreen_spacer_35',
        'mobilegrid_58': 'startScreen_mobilegrid_58',
        'mobilegridcell_59': 'startScreen_mobilegridcell_59',
        'mobilegrid_36': 'startScreen_mobilegrid_36',
        'gridcell1': 'startScreen_gridcell1',
        'company': 'startScreen_company',
        'gridcell2': 'startScreen_gridcell2',
        'product': 'startScreen_product',
        'no_records': 'startScreen_no_records',
        'mobilegrid_50': 'startScreen_mobilegrid_50',
        'mobilegridcell_51': 'startScreen_mobilegridcell_51',
        'mobilegridcell_52': 'startScreen_mobilegridcell_52',
        'mobilebutton_38': 'startScreen_mobilebutton_38'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fix for jQuery Mobile's footer in Cordova webview on WP8 devices
        var msViewportStyle = document.createElement("style");
        msViewportStyle.appendChild(
        document.createTextNode("@media screen and (orientation: portrait){@-ms-viewport {width: 320px; height: 536px;user-zoom: fixed;max-zoom: 1;min-zoom: 1;}}" + "@media screen and (orientation:landscape){@-ms-viewport{width:480px;user-zoom:fixed;max-zoom:1;min-zoom:1;}}"));
        document.getElementsByTagName("head")[0].appendChild(msViewportStyle);
    }

    Apperyio.CurrentScreen = 'startScreen';

    /*
     * Nonvisual components
     */
    var datasources = [];

    search_service_clone_1 = new Apperyio.DataSource(Veg_Veg_query_service, {
        'onBeforeSend': function(jqXHR) {

        },
        'onComplete': function(jqXHR, textStatus) {
            if (jqXHR.responseText == "[]") {
                Appery("no_records").text("Nothing vegan found matching your description. Please search again.");
                Appery("no_records").show();
            };

            Apperyio.refreshScreenFormElements("startScreen");
        },
        'onSuccess': function(data) {},
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['$'],
            'ID': 'mobilegrid_36',
            'SET': [{
                'PATH': ['Company'],
                'ID': 'company',
                'ATTR': '@'
            }, {
                'PATH': ['Product'],
                'ID': 'product',
                'ATTR': '@'
            }]
        }],
        'requestMapping': [{
            'PATH': ['X-Appery-Database-Id'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ATTR': '{database_id}'
        }, {
            'PATH': ['where'],
            'TYPE': 'STRING',
            'ID': 'search_bar',
            'ATTR': 'value',
            'TRANSFORMATION': function(value) {
                return '{"$or":[{"Product":{"$regex":"(?=.*' + value.replace(/ /g, ")(?=.*") + ')","$options":"im"}},{"Type":{"$regex":"(?=.*' + value.replace(/ /g, ")(?=.*") + ')","$options":"im"}},{"Company":{"$regex":"(?=.*' + value.replace(/ /g, ")(?=.*") + ')","$options":"im"}}]}';

                //return '{"$or":[{"Product":{"$regex":"' + value.replace(/ /g, "|") + '","$options":"im"}},{"Company":{"$regex":"' + value.replace(/ /g, "|") + '","$options":"im"}}]}';

                //return '{"$or":[{"Product":{"$regex":"(?=.*' + value.replace(/ /g, ")(?=.*") + ')","$options":"im"}},{"Type":{"$regex":"(?=.*' + value.replace(/ /g, ")(?=.*") + ')","$options":"im"}},{"Company":{"$regex":"(?=.*' + value.replace(/ /g, ")(?=.*") + ')","$options":"im"}}]}';
            }
        }, {
            'PATH': ['limit'],
            'TYPE': 'STRING',
            'ATTR': '1500'
        }]
    });

    datasources.push(search_service_clone_1);

    /*
     * Events and handlers
     */

    // Before Show
    var startScreen_beforeshow = function() {
            Apperyio.CurrentScreen = "startScreen";
            for (var idx = 0; idx < datasources.length; idx++) {
                datasources[idx].__setupDisplay();
            }
        };

    // On Load
    var startScreen_onLoad = function() {
            startScreen_elementsExtraJS();

            // TODO fire device events only if necessary (with JS logic)
            startScreen_deviceEvents();
            startScreen_windowEvents();
            startScreen_elementsEvents();
        };

    // screen window events
    var startScreen_windowEvents = function() {

            $('#startScreen').bind('pageshow orientationchange', function() {
                var _page = this;
                adjustContentHeightWithPadding(_page);
            });

        };

    // device events
    var startScreen_deviceEvents = function() {
            document.addEventListener("deviceready", function() {

            });
        };

    // screen elements extra js
    var startScreen_elementsExtraJS = function() {
            // screen (startScreen) extra code

        };

    // screen elements handler
    var startScreen_elementsEvents = function() {
            $(document).on("click", "a :input,a a,a fieldset label", function(event) {
                event.stopPropagation();
            });

            $(document).off("vclick", "#startScreen_search_bar-cover-img").on({
                vclick: function() {
                    if (!$(this).attr('disabled')) {
                        Appery("no_records").hide();
                        try {
                            search_service_clone_1.execute({})
                        } catch (ex) {
                            console.log(ex.name + '  ' + ex.message);
                            hideSpinner();
                        };
                    }
                }
            }, "#startScreen_search_bar-cover-img");

            $(document).off("click", '#startScreen_mobilecontainer [name="mobileimage_57"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        try {
                            search_service_clone_1.execute({})
                        } catch (ex) {
                            console.log(ex.name + '  ' + ex.message);
                            hideSpinner();
                        };

                    }
                },
            }, '#startScreen_mobilecontainer [name="mobileimage_57"]');

            $(document).off("click", '#startScreen_mobilefooter [name="mobilebutton_38"]').on({
                click: function() {
                    if (!$(this).attr('disabled')) {
                        Apperyio.navigateTo('Info', {
                            transition: 'flip',
                            reverse: false
                        });

                    }
                },
            }, '#startScreen_mobilefooter [name="mobilebutton_38"]');

        };

    $(document).off("pagebeforeshow", "#startScreen").on("pagebeforeshow", "#startScreen", function(event, ui) {
        startScreen_beforeshow();
    });

    if (runBeforeShow) {
        startScreen_beforeshow();
    } else {
        startScreen_onLoad();
    }
};

$(document).off("pagecreate", "#startScreen").on("pagecreate", "#startScreen", function(event, ui) {
    Apperyio.processSelectMenu($(this));
    startScreen_js();
});